package com.patzn.cloud.service.lims.hmhj.service.impl;

import com.baomidou.mybatisplus.mapper.Condition;
import com.patzn.cloud.commons.api.RestAssert;
import com.patzn.cloud.commons.controller.Account;
import com.patzn.cloud.service.hmhj.entity.ContractSample;
import com.patzn.cloud.service.hmhj.enums.ContractSampleStatusEnum;
import com.patzn.cloud.service.lims.hmhj.mapper.ContractSampleMapper;
import com.patzn.cloud.service.lims.hmhj.service.IContractSampleService;
import com.patzn.cloud.commons.service.impl.BaseServiceImpl;
import org.apache.commons.lang3.ArrayUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.mapper.Wrapper;
import com.baomidou.mybatisplus.plugins.Page;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 *  服务实现类
 *
 * @author wwd
 * @since 2021-02-01
 */
@Service
public class ContractSampleServiceImpl extends BaseServiceImpl<ContractSampleMapper, ContractSample> implements IContractSampleService {

    @Override
    public Page<ContractSample> page(Page<ContractSample> page, ContractSample contractSample) {
        Wrapper wrapper = new EntityWrapper<>(contractSample);

        return this.page(page, wrapper);
    }


    @Override
    public Page<ContractSample> pageByIds(Page<ContractSample> page, Long [] ids) {
        Wrapper wrapper = new EntityWrapper<>();
        wrapper.in("id",ids);
        return this.page(page, wrapper);
    }

    @Override
    public boolean removeByIds(List<Long> ids) {
        return baseMapper.deleteBatchIds(ids) > 0;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean submitToStoreTransport(Long[] ids, Account account) {
        RestAssert.fail(ArrayUtils.isEmpty(ids),"请选择要提交的合同！");
        ContractSample contractSample = new ContractSample();
        contractSample.setStatus(ContractSampleStatusEnum.STORE_TRANSPORT);
        contractSample.setProgress(ContractSampleStatusEnum.STORE_TRANSPORT);
        return super.update(contractSample,Condition.create().in("id",ids));
    }
}
